diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-phy.cc ns-3.34/src/wifi/model/wifi-phy.cc
--- ns-3.33/src/wifi/model/wifi-phy.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-phy.cc	2021-07-14 10:31:07.000000000 -0700
@@ -291,26 +300,69 @@
     .SetParent<Object> ()
     .SetGroupName ("Wifi")
     .AddAttribute ("Frequency",
-                   "The operating center frequency (MHz)",
+                   "The center frequency (MHz) of the operating channel. "
+                   "If the operating channel for this object has not been set yet, the "
+                   "value of this attribute is saved and will be used, along with the channel "
+                   "number and width configured via other attributes, to set the operating "
+                   "channel when the standard and band are configured. The default value of "
+                   "this attribute is 0, which means unspecified center frequency. Note that "
+                   "if center frequency and channel number are both 0 when the standard and "
+                   "band are configured, a default channel (of the configured width, if any, "
+                   "or the default width for the current standard and band, otherwise) is set. "
+                   "If the operating channel for this object has been already set, the "
+                   "specified center frequency must uniquely identify a channel in the "
+                   "band being used.",
                    UintegerValue (0),
                    MakeUintegerAccessor (&WifiPhy::GetFrequency,
                                          &WifiPhy::SetFrequency),
                    MakeUintegerChecker<uint16_t> ())
-    .AddAttribute ("ChannelWidth",
-                   "Whether 5MHz, 10MHz, 20MHz, 22MHz, 40MHz, 80 MHz or 160 MHz.",
-                   UintegerValue (20),
-                   MakeUintegerAccessor (&WifiPhy::GetChannelWidth,
-                                         &WifiPhy::SetChannelWidth),
-                   MakeUintegerChecker<uint16_t> (5, 160))
     .AddAttribute ("ChannelNumber",
-                   "If set to non-zero defined value, will control Frequency and ChannelWidth assignment",
+                   "The channel number of the operating channel. "
+                   "If the operating channel for this object has not been set yet, the "
+                   "value of this attribute is saved and will be used, along with the center "
+                   "frequency and width configured via other attributes, to set the operating "
+                   "channel when the standard and band are configured. The default value of "
+                   "this attribute is 0, which means unspecified channel number. Note that "
+                   "if center frequency and channel number are both 0 when the standard and "
+                   "band are configured, a default channel (of the configured width, if any, "
+                   "or the default width for the current standard and band, otherwise) is set. "
+                   "If the operating channel for this object has been already set, the "
+                   "specified channel number must uniquely identify a channel in the "
+                   "band being used.",
                    UintegerValue (0),
                    MakeUintegerAccessor (&WifiPhy::SetChannelNumber,
                                          &WifiPhy::GetChannelNumber),
                    MakeUintegerChecker<uint8_t> (0, 233))
+    .AddAttribute ("ChannelWidth",
+                   "The width in MHz of the operating channel (5, 10, 20, 22, 40, 80 or 160). "
+                   "If the operating channel for this object has not been set yet, the "
+                   "value of this attribute is saved and will be used, along with the center "
+                   "frequency and channel number configured via other attributes, to set the "
+                   "operating channel when the standard and band are configured. The default value "
+                   "of this attribute is 0, which means unspecified channel width. Note that "
+                   "if center frequency and channel number are both 0 when the standard and "
+                   "band are configured, a default channel (of the configured width, if any, "
+                   "or the default width for the current standard and band, otherwise) is set. "
+                   "Do not set this attribute when the standard and band of this object have "
+                   "been already configured, because it cannot uniquely identify a channel in "
+                   "the band being used.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiPhy::GetChannelWidth,
+                                         &WifiPhy::SetChannelWidth),
+                   MakeUintegerChecker<uint16_t> (5, 160))
+    .AddAttribute ("Primary20MHzIndex",
+                   "The index of the primary 20 MHz channel within the operating channel "
+                   "(0 indicates the 20 MHz subchannel with the lowest center frequency). "
+                   "This attribute is only valid if the width of the operating channel is "
+                   "a multiple of 20 MHz.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiPhy::SetPrimary20Index),
+                   MakeUintegerChecker<uint8_t> (0, 7))
     .AddAttribute ("RxSensitivity",
                    "The energy of a received signal should be higher than "
-                   "this threshold (dBm) for the PHY to detect the signal.",
+                   "this threshold (dBm) for the PHY to detect the signal. "
+                   "This threshold refers to a width of 20 MHz and will be "
+                   "scaled to match the width of the received signal.",
                    DoubleValue (-101.0),
                    MakeDoubleAccessor (&WifiPhy::SetRxSensitivity,
                                        &WifiPhy::GetRxSensitivity),
@@ -443,6 +495,12 @@
                    TimeValue (MicroSeconds (0)),
                    MakeTimeAccessor (&WifiPhy::m_pifs),
                    MakeTimeChecker ())
+    .AddAttribute ("PowerDensityLimit",
+                   "The mean equivalent isotropically radiated power density"
+                   "limit (in dBm/MHz) set by regulators.",
+                   DoubleValue (100.0), //set to a high value so as to have no effect
+                   MakeDoubleAccessor (&WifiPhy::m_powerDensityLimit),
+                   MakeDoubleChecker<double> ())
     .AddTraceSource ("PhyTxBegin",
                      "Trace source indicating a packet "
                      "has begun transmitting over the channel medium",
@@ -495,10 +553,6 @@
                      "in monitor mode to sniff all frames being transmitted",
                      MakeTraceSourceAccessor (&WifiPhy::m_phyMonitorSniffTxTrace),
                      "ns3::WifiPhy::MonitorSnifferTxTracedCallback")
-    .AddTraceSource ("EndOfHePreamble",
-                     "Trace source indicating the end of the 802.11ax preamble (after training fields)",
-                     MakeTraceSourceAccessor (&WifiPhy::m_phyEndOfHePreambleTrace),
-                     "ns3::WifiPhy::EndOfHePreambleTracedCallback")
   ;
   return tid;
 }
@@ -506,17 +560,16 @@
 WifiPhy::WifiPhy ()
   : m_txMpduReferenceNumber (0xffffffff),
     m_rxMpduReferenceNumber (0xffffffff),
-    m_endRxEvent (),
     m_endPhyRxEvent (),
-    m_endPreambleDetectionEvent (),
     m_endTxEvent (),
+    m_currentEvent (0),
+    m_previouslyRxPpduUid (UINT64_MAX),
     m_standard (WIFI_PHY_STANDARD_UNSPECIFIED),
     m_band (WIFI_PHY_BAND_UNSPECIFIED),
-    m_isConstructed (false),
-    m_channelCenterFrequency (0),
     m_initialFrequency (0),
-    m_frequencyChannelNumberInitialized (false),
-    m_channelWidth (0),
+    m_initialChannelNumber (0),
+    m_initialChannelWidth (0),
+    m_initialPrimary20Index (0),
     m_sifs (Seconds (0)),
     m_slot (Seconds (0)),
     m_pifs (Seconds (0)),
@@ -526,9 +579,6 @@
     m_channelAccessRequested (false),
     m_txSpatialStreams (0),
     m_rxSpatialStreams (0),
-    m_channelNumber (0),
-    m_initialChannelNumber (0),
-    m_currentEvent (0),
     m_wifiRadioEnergyModel (0),
     m_timeLastPreambleDetected (Seconds (0))
 {
@@ -547,30 +597,32 @@
 {
   NS_LOG_FUNCTION (this);
   m_endTxEvent.Cancel ();
-  m_endRxEvent.Cancel ();
   m_endPhyRxEvent.Cancel ();
-  m_endPreambleDetectionEvent.Cancel ();
+  for (auto & phyEntity : m_phyEntities)
+    {
+      phyEntity.second->CancelAllEvents ();
+    }
   m_device = 0;
   m_mobility = 0;
-  m_state = 0;
+  m_frameCaptureModel = 0;
+  m_preambleDetectionModel = 0;
   m_wifiRadioEnergyModel = 0;
   m_postReceptionErrorModel = 0;
-  m_deviceRateSet.clear ();
-  m_deviceMcsSet.clear ();
-  m_mcsIndexMap.clear ();
-}
+  m_supportedChannelWidthSet.clear ();
+  m_random = 0;
+  m_state = 0;
+  m_currentEvent = 0;
+  for (auto & preambleEvent : m_currentPreambleEvents)
+    {
+      preambleEvent.second = 0;
+    }
+  m_currentPreambleEvents.clear ();
 
-void
-WifiPhy::DoInitialize (void)
-{
-  NS_LOG_FUNCTION (this);
-  m_isConstructed = true;
-  if (m_frequencyChannelNumberInitialized == true)
+  for (auto & phyEntity : m_phyEntities)
     {
-      NS_LOG_DEBUG ("Frequency already initialized");
-      return;
+      phyEntity.second = 0;
     }
-  InitializeFrequencyChannelNumber ();
+  m_phyEntities.clear ();
 }
 
 Ptr<WifiPhyStateHelper>
@@ -610,34 +662,6 @@
 }
 
 void
-WifiPhy::InitializeFrequencyChannelNumber (void)
-{
-  NS_LOG_FUNCTION (this);
-
-  NS_ASSERT_MSG (m_frequencyChannelNumberInitialized == false, "Initialization called twice");
-
-  // If frequency has been set to a non-zero value during attribute
-  // construction phase, the frequency and channel width will drive the
-  // initial configuration.  If frequency has not been set, but both
-  // standard and channel number have been set, that pair will instead
-  // drive the configuration, and frequency and channel number will be
-  // aligned
-  if (m_initialFrequency != 0)
-    {
-      SetFrequency (m_initialFrequency);
-    }
-  else if (m_initialChannelNumber != 0 && GetPhyStandard () != WIFI_PHY_STANDARD_UNSPECIFIED)
-    {
-      SetChannelNumber (m_initialChannelNumber);
-    }
-  else if (m_initialChannelNumber != 0 && GetPhyStandard () == WIFI_PHY_STANDARD_UNSPECIFIED)
-    {
-      NS_FATAL_ERROR ("Error, ChannelNumber " << +GetChannelNumber () << " was set by user, but neither a standard nor a frequency");
-    }
-  m_frequencyChannelNumberInitialized = true;
-}
-
-void
 WifiPhy::SetRxSensitivity (double threshold)
 {
   NS_LOG_FUNCTION (this << threshold);
@@ -837,107 +861,43 @@
 }
 
 double
-WifiPhy::CalculateSnr (WifiTxVector txVector, double ber) const
+WifiPhy::CalculateSnr (const WifiTxVector& txVector, double ber) const
 {
   return m_interference.GetErrorRateModel ()->CalculateSnr (txVector, ber);
 }
 
+const Ptr<const PhyEntity>
+WifiPhy::GetStaticPhyEntity (WifiModulationClass modulation)
+{
+  const auto it = m_staticPhyEntities.find (modulation);
+  NS_ABORT_MSG_IF (it == m_staticPhyEntities.end (), "Unimplemented Wi-Fi modulation class");
+  return it->second;
+}
+
+Ptr<PhyEntity>
+WifiPhy::GetPhyEntity (WifiModulationClass modulation) const
+{
+  const auto it = m_phyEntities.find (modulation);
+  NS_ABORT_MSG_IF (it == m_phyEntities.end (), "Unsupported Wi-Fi modulation class");
+  return it->second;
+}
+
 void
-WifiPhy::ConfigureDefaultsForStandard (void)
+WifiPhy::AddStaticPhyEntity (WifiModulationClass modulation, Ptr<PhyEntity> phyEntity)
 {
-  NS_LOG_FUNCTION (this);
-  switch (m_standard)
-    {
-    case WIFI_PHY_STANDARD_80211a:
-      SetChannelWidth (20);
-      SetFrequency (5180);
-      // Channel number should be aligned by SetFrequency () to 36
-      NS_ASSERT (GetChannelNumber () == 36);
-      break;
-    case WIFI_PHY_STANDARD_80211b:
-      SetChannelWidth (22);
-      SetFrequency (2412);
-      // Channel number should be aligned by SetFrequency () to 1
-      NS_ASSERT (GetChannelNumber () == 1);
-      break;
-    case WIFI_PHY_STANDARD_80211g:
-      SetChannelWidth (20);
-      SetFrequency (2412);
-      // Channel number should be aligned by SetFrequency () to 1
-      NS_ASSERT (GetChannelNumber () == 1);
-      break;
-    case WIFI_PHY_STANDARD_80211p:
-      if (GetChannelWidth () > 10)
-        {
-          SetChannelWidth (10);
-        }
-      SetFrequency (5860);
-      // Channel number should be aligned by SetFrequency () to either 172 or 171
-      NS_ASSERT ((GetChannelWidth () == 10 && GetChannelNumber () == 172) || (GetChannelWidth () == 5 && GetChannelNumber () == 171)) ;
-      break;
-    case WIFI_PHY_STANDARD_holland:
-      SetChannelWidth (20);
-      SetFrequency (5180);
-      // Channel number should be aligned by SetFrequency () to 36
-      NS_ASSERT (GetChannelNumber () == 36);
-      break;
-    case WIFI_PHY_STANDARD_80211n:
-      SetChannelWidth (20);
-      if (m_band == WIFI_PHY_BAND_2_4GHZ)
-        {
-          SetFrequency (2412);
-          // Channel number should be aligned by SetFrequency () to 1
-          NS_ASSERT (GetChannelNumber () == 1);
-        }
-      else if (m_band == WIFI_PHY_BAND_5GHZ)
-        {
-          SetFrequency (5180);
-          // Channel number should be aligned by SetFrequency () to 36
-          NS_ASSERT (GetChannelNumber () == 36);
-        }
-      else
-        {
-          NS_FATAL_ERROR ("Invalid band");
-        }
-      break;
-    case WIFI_PHY_STANDARD_80211ac:
-      SetChannelWidth (80);
-      SetFrequency (5210);
-      // Channel number should be aligned by SetFrequency () to 42
-      NS_ASSERT (GetChannelNumber () == 42);
-      break;
-    case WIFI_PHY_STANDARD_80211ax:
-      if (m_band == WIFI_PHY_BAND_2_4GHZ)
-        {
-          SetChannelWidth (20);
-          SetFrequency (2412);
-          // Channel number should be aligned by SetFrequency () to 1
-          NS_ASSERT (GetChannelNumber () == 1);
-        }
-      else if (m_band == WIFI_PHY_BAND_5GHZ)
-        {
-          SetChannelWidth (80);
-          SetFrequency (5210);
-          // Channel number should be aligned by SetFrequency () to 42
-          NS_ASSERT (GetChannelNumber () == 42);
-        }
-      else if (m_band == WIFI_PHY_BAND_6GHZ)
-        {
-          SetChannelWidth (80);
-          SetFrequency (5975);
-          // Channel number should be aligned by SetFrequency () to 7
-          NS_ASSERT (GetChannelNumber () == 7);
-        }
-      else
-        {
-          NS_FATAL_ERROR ("Invalid band");
-        }
-      break;
-    case WIFI_PHY_STANDARD_UNSPECIFIED:
-    default:
-      NS_LOG_WARN ("Configuring unspecified standard; performing no action");
-      break;
-    }
+  NS_LOG_FUNCTION (modulation);
+  NS_ASSERT_MSG (m_staticPhyEntities.find (modulation) == m_staticPhyEntities.end (), "The PHY entity has already been added. The setting should only be done once per modulation class");
+  m_staticPhyEntities[modulation] = phyEntity;
+}
+
+void
+WifiPhy::AddPhyEntity (WifiModulationClass modulation, Ptr<PhyEntity> phyEntity)
+{
+  NS_LOG_FUNCTION (this << modulation);
+  NS_ABORT_MSG_IF (m_staticPhyEntities.find (modulation) == m_staticPhyEntities.end (), "Cannot add an unimplemented PHY to supported list. Update the former first.");
+  NS_ASSERT_MSG (m_phyEntities.find (modulation) == m_phyEntities.end (), "The PHY entity has already been added. The setting should only be done once per modulation class");
+  phyEntity->SetOwner (this);
+  m_phyEntities[modulation] = phyEntity;
 }
 
 void
@@ -992,6 +952,7 @@
 WifiPhy::Configure80211a (void)
 {
   NS_LOG_FUNCTION (this);
+  AddPhyEntity (WIFI_MOD_CLASS_OFDM, Create<OfdmPhy> ());
 
   // See Table 17-21 "OFDM PHY characteristics" of 802.11-2016
   SetSifs (MicroSeconds (16));
@@ -1000,21 +961,15 @@
   // See Table 10-5 "Determination of the EstimatedAckTxTime based on properties
   // of the PPDU causing the EIFS" of 802.11-2016
   m_ackTxTime = MicroSeconds (44);
-
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate6Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate9Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate12Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate18Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate24Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate36Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate48Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate54Mbps ());
 }
 
 void
 WifiPhy::Configure80211b (void)
 {
   NS_LOG_FUNCTION (this);
+  Ptr<DsssPhy> phyEntity = Create<DsssPhy> ();
+  AddPhyEntity (WIFI_MOD_CLASS_HR_DSSS, phyEntity);
+  AddPhyEntity (WIFI_MOD_CLASS_DSSS, phyEntity); //when plain DSSS modes are used
 
   // See Table 16-4 "HR/DSSS PHY characteristics" of 802.11-2016
   SetSifs (MicroSeconds (10));
@@ -1023,11 +978,6 @@
   // See Table 10-5 "Determination of the EstimatedAckTxTime based on properties
   // of the PPDU causing the EIFS" of 802.11-2016
   m_ackTxTime = MicroSeconds (304);
-
-  m_deviceRateSet.push_back (WifiPhy::GetDsssRate1Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetDsssRate2Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetDsssRate5_5Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetDsssRate11Mbps ());
 }
 
 void
@@ -1040,15 +990,7 @@
   // if the user sets the ShortSlotTimeSupported flag to true and when the BSS
   // consists of only ERP STAs capable of supporting this option.
   Configure80211b ();
-
-  m_deviceRateSet.push_back (WifiPhy::GetErpOfdmRate6Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetErpOfdmRate9Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetErpOfdmRate12Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetErpOfdmRate18Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetErpOfdmRate24Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetErpOfdmRate36Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetErpOfdmRate48Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetErpOfdmRate54Mbps ());
+  AddPhyEntity (WIFI_MOD_CLASS_ERP_OFDM, Create<ErpOfdmPhy> ());
 }
 
 void
@@ -1057,37 +999,23 @@
   NS_LOG_FUNCTION (this);
   if (GetChannelWidth () == 10)
     {
+      AddPhyEntity (WIFI_MOD_CLASS_OFDM, Create<OfdmPhy> (OFDM_PHY_10_MHZ));
+
       // See Table 17-21 "OFDM PHY characteristics" of 802.11-2016
       SetSifs (MicroSeconds (32));
       SetSlot (MicroSeconds (13));
       SetPifs (GetSifs () + GetSlot ());
       m_ackTxTime = MicroSeconds (88);
-
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate3MbpsBW10MHz ());
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate4_5MbpsBW10MHz ());
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate6MbpsBW10MHz ());
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate9MbpsBW10MHz ());
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate12MbpsBW10MHz ());
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate18MbpsBW10MHz ());
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate24MbpsBW10MHz ());
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate27MbpsBW10MHz ());
     }
   else if (GetChannelWidth () == 5)
     {
+      AddPhyEntity (WIFI_MOD_CLASS_OFDM, Create<OfdmPhy> (OFDM_PHY_5_MHZ));
+
       // See Table 17-21 "OFDM PHY characteristics" of 802.11-2016
       SetSifs (MicroSeconds (64));
       SetSlot (MicroSeconds (21));
       SetPifs (GetSifs () + GetSlot ());
       m_ackTxTime = MicroSeconds (176);
-
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate1_5MbpsBW5MHz ());
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate2_25MbpsBW5MHz ());
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate3MbpsBW5MHz ());
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate4_5MbpsBW5MHz ());
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate6MbpsBW5MHz ());
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate9MbpsBW5MHz ());
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate12MbpsBW5MHz ());
-      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate13_5MbpsBW5MHz ());
     }
   else
     {
@@ -1096,117 +1024,6 @@
 }
 
 void
-WifiPhy::ConfigureHolland (void)
-{
-  NS_LOG_FUNCTION (this);
-
-  SetSifs (MicroSeconds (16));
-  SetSlot (MicroSeconds (9));
-  SetPifs (GetSifs () + GetSlot ());
-
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate6Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate12Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate18Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate36Mbps ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate54Mbps ());
-}
-
-void
-WifiPhy::PushMcs (WifiMode mode)
-{
-  NS_LOG_FUNCTION (this << mode);
-
-  WifiModulationClass modulation = mode.GetModulationClass ();
-  NS_ASSERT (modulation == WIFI_MOD_CLASS_HT || modulation == WIFI_MOD_CLASS_VHT
-             || modulation == WIFI_MOD_CLASS_HE);
-
-  m_mcsIndexMap[modulation][mode.GetMcsValue ()] = m_deviceMcsSet.size ();
-  m_deviceMcsSet.push_back (mode);
-}
-
-void
-WifiPhy::RebuildMcsMap (void)
-{
-  NS_LOG_FUNCTION (this);
-  m_mcsIndexMap.clear ();
-  uint8_t index = 0;
-  for (auto& mode : m_deviceMcsSet)
-    {
-      m_mcsIndexMap[mode.GetModulationClass ()][mode.GetMcsValue ()] = index++;
-    }
-}
-
-void
-WifiPhy::ConfigureHtDeviceMcsSet (void)
-{
-  NS_LOG_FUNCTION (this);
-
-  bool htFound = false;
-  for (std::vector<uint8_t>::size_type i = 0; i < m_bssMembershipSelectorSet.size (); i++)
-    {
-      if (m_bssMembershipSelectorSet[i] == HT_PHY)
-        {
-          htFound = true;
-          break;
-        }
-    }
-  if (htFound)
-    {
-      // erase all HtMcs modes from deviceMcsSet
-      std::size_t index = m_deviceMcsSet.size () - 1;
-      for (std::vector<WifiMode>::reverse_iterator rit = m_deviceMcsSet.rbegin (); rit != m_deviceMcsSet.rend (); ++rit, --index)
-        {
-          if (m_deviceMcsSet[index].GetModulationClass () == WIFI_MOD_CLASS_HT)
-            {
-              m_deviceMcsSet.erase (m_deviceMcsSet.begin () + index);
-            }
-        }
-      RebuildMcsMap ();
-      PushMcs (WifiPhy::GetHtMcs0 ());
-      PushMcs (WifiPhy::GetHtMcs1 ());
-      PushMcs (WifiPhy::GetHtMcs2 ());
-      PushMcs (WifiPhy::GetHtMcs3 ());
-      PushMcs (WifiPhy::GetHtMcs4 ());
-      PushMcs (WifiPhy::GetHtMcs5 ());
-      PushMcs (WifiPhy::GetHtMcs6 ());
-      PushMcs (WifiPhy::GetHtMcs7 ());
-      if (GetMaxSupportedTxSpatialStreams () > 1)
-        {
-          PushMcs (WifiPhy::GetHtMcs8 ());
-          PushMcs (WifiPhy::GetHtMcs9 ());
-          PushMcs (WifiPhy::GetHtMcs10 ());
-          PushMcs (WifiPhy::GetHtMcs11 ());
-          PushMcs (WifiPhy::GetHtMcs12 ());
-          PushMcs (WifiPhy::GetHtMcs13 ());
-          PushMcs (WifiPhy::GetHtMcs14 ());
-          PushMcs (WifiPhy::GetHtMcs15 ());
-        }
-      if (GetMaxSupportedTxSpatialStreams () > 2)
-        {
-          PushMcs (WifiPhy::GetHtMcs16 ());
-          PushMcs (WifiPhy::GetHtMcs17 ());
-          PushMcs (WifiPhy::GetHtMcs18 ());
-          PushMcs (WifiPhy::GetHtMcs19 ());
-          PushMcs (WifiPhy::GetHtMcs20 ());
-          PushMcs (WifiPhy::GetHtMcs21 ());
-          PushMcs (WifiPhy::GetHtMcs22 ());
-          PushMcs (WifiPhy::GetHtMcs23 ());
-        }
-      if (GetMaxSupportedTxSpatialStreams () > 3)
-        {
-          PushMcs (WifiPhy::GetHtMcs24 ());
-          PushMcs (WifiPhy::GetHtMcs25 ());
-          PushMcs (WifiPhy::GetHtMcs26 ());
-          PushMcs (WifiPhy::GetHtMcs27 ());
-          PushMcs (WifiPhy::GetHtMcs28 ());
-          PushMcs (WifiPhy::GetHtMcs29 ());
-          PushMcs (WifiPhy::GetHtMcs30 ());
-          PushMcs (WifiPhy::GetHtMcs31 ());
-        }
-    }
-}
-
-void
 WifiPhy::Configure80211n (void)
 {
   NS_LOG_FUNCTION (this);
@@ -1218,11 +1035,11 @@
     {
       Configure80211a ();
     }
+  AddPhyEntity (WIFI_MOD_CLASS_HT, Create<HtPhy> (m_txSpatialStreams));
+
   // See Table 10-5 "Determination of the EstimatedAckTxTime based on properties
   // of the PPDU causing the EIFS" of 802.11-2016
   m_blockAckTxTime = MicroSeconds (68);
-  m_bssMembershipSelectorSet.push_back (HT_PHY);
-  ConfigureHtDeviceMcsSet ();
 }
 
 void
@@ -1230,19 +1047,7 @@
 {
   NS_LOG_FUNCTION (this);
   Configure80211n ();
-
-  PushMcs (WifiPhy::GetVhtMcs0 ());
-  PushMcs (WifiPhy::GetVhtMcs1 ());
-  PushMcs (WifiPhy::GetVhtMcs2 ());
-  PushMcs (WifiPhy::GetVhtMcs3 ());
-  PushMcs (WifiPhy::GetVhtMcs4 ());
-  PushMcs (WifiPhy::GetVhtMcs5 ());
-  PushMcs (WifiPhy::GetVhtMcs6 ());
-  PushMcs (WifiPhy::GetVhtMcs7 ());
-  PushMcs (WifiPhy::GetVhtMcs8 ());
-  PushMcs (WifiPhy::GetVhtMcs9 ());
-
-  m_bssMembershipSelectorSet.push_back (VHT_PHY);
+  AddPhyEntity (WIFI_MOD_CLASS_VHT, Create<VhtPhy> ());
 }
 
 void
@@ -1257,116 +1062,7 @@
     {
       Configure80211ac ();
     }
-
-  PushMcs (WifiPhy::GetHeMcs0 ());
-  PushMcs (WifiPhy::GetHeMcs1 ());
-  PushMcs (WifiPhy::GetHeMcs2 ());
-  PushMcs (WifiPhy::GetHeMcs3 ());
-  PushMcs (WifiPhy::GetHeMcs4 ());
-  PushMcs (WifiPhy::GetHeMcs5 ());
-  PushMcs (WifiPhy::GetHeMcs6 ());
-  PushMcs (WifiPhy::GetHeMcs7 ());
-  PushMcs (WifiPhy::GetHeMcs8 ());
-  PushMcs (WifiPhy::GetHeMcs9 ());
-  PushMcs (WifiPhy::GetHeMcs10 ());
-  PushMcs (WifiPhy::GetHeMcs11 ());
-
-  m_bssMembershipSelectorSet.push_back (HE_PHY);
-}
-
-bool
-WifiPhy::DefineChannelNumber (uint8_t channelNumber, WifiPhyBand band, WifiPhyStandard standard, uint16_t frequency, uint16_t channelWidth)
-{
-  NS_LOG_FUNCTION (this << +channelNumber << band << standard << frequency << channelWidth);
-  ChannelNumberStandardPair p = std::make_pair (std::make_pair (channelNumber, band), standard);
-  ChannelToFrequencyWidthMap::const_iterator it;
-  it = m_channelToFrequencyWidth.find (p);
-  if (it != m_channelToFrequencyWidth.end ())
-    {
-      NS_LOG_DEBUG ("channel number/standard already defined; returning false");
-      return false;
-    }
-  FrequencyWidthPair f = std::make_pair (frequency, channelWidth);
-  m_channelToFrequencyWidth[p] = f;
-  return true;
-}
-
-uint8_t
-WifiPhy::FindChannelNumberForFrequencyWidth (uint16_t frequency, uint16_t width) const
-{
-  NS_LOG_FUNCTION (this << frequency << width);
-  bool found = false;
-  FrequencyWidthPair f = std::make_pair (frequency, width);
-  ChannelToFrequencyWidthMap::const_iterator it = m_channelToFrequencyWidth.begin ();
-  while (it != m_channelToFrequencyWidth.end ())
-    {
-      if (it->second == f)
-        {
-          found = true;
-          break;
-        }
-      ++it;
-    }
-  if (found)
-    {
-      NS_LOG_DEBUG ("Found, returning " << +it->first.first.first);
-      return (it->first.first.first);
-    }
-  else
-    {
-      NS_LOG_DEBUG ("Not found, returning 0");
-      return 0;
-    }
-}
-
-void
-WifiPhy::ConfigureChannelForStandard (void)
-{
-  NS_LOG_FUNCTION (this);
-  // If the user has configured both Frequency and ChannelNumber, Frequency
-  // takes precedence
-  if (GetFrequency () != 0)
-    {
-      // If Frequency is already set, then see whether a ChannelNumber can
-      // be found that matches Frequency and ChannelWidth. If so, configure
-      // the ChannelNumber to that channel number. If not, set ChannelNumber to zero.
-      NS_LOG_DEBUG ("Frequency set; checking whether a channel number corresponds");
-      uint8_t channelNumberSearched = FindChannelNumberForFrequencyWidth (GetFrequency (), GetChannelWidth ());
-      if (channelNumberSearched)
-        {
-          NS_LOG_DEBUG ("Channel number found; setting to " << +channelNumberSearched);
-          SetChannelNumber (channelNumberSearched);
-        }
-      else
-        {
-          NS_LOG_DEBUG ("Channel number not found; setting to zero");
-          SetChannelNumber (0);
-        }
-    }
-  else if (GetChannelNumber () != 0)
-    {
-      // If the channel number is known for this particular standard or for
-      // the unspecified standard, configure using the known values;
-      // otherwise, this is a configuration error
-      NS_LOG_DEBUG ("Configuring for channel number " << +GetChannelNumber ());
-      FrequencyWidthPair f = GetFrequencyWidthForChannelNumberStandard (GetChannelNumber (), GetPhyBand (), GetPhyStandard ());
-      if (f.first == 0)
-        {
-          // the specific pair of number/standard is not known
-          NS_LOG_DEBUG ("Falling back to check WIFI_PHY_STANDARD_UNSPECIFIED");
-          f = GetFrequencyWidthForChannelNumberStandard (GetChannelNumber (), GetPhyBand (), WIFI_PHY_STANDARD_UNSPECIFIED);
-        }
-      if (f.first == 0)
-        {
-          NS_FATAL_ERROR ("Error, ChannelNumber " << +GetChannelNumber () << " is unknown for this standard");
-        }
-      else
-        {
-          NS_LOG_DEBUG ("Setting frequency to " << f.first << "; width to " << +f.second);
-          SetFrequency (f.first);
-          SetChannelWidth (f.second);
-        }
-    }
+  AddPhyEntity (WIFI_MOD_CLASS_HE, Create<HePhy> ());
 }
 
 void
@@ -1375,20 +1071,25 @@
   NS_LOG_FUNCTION (this << standard << band);
   m_standard = standard;
   m_band = band;
-  m_isConstructed = true;
-  if (m_frequencyChannelNumberInitialized == false)
-    {
-      InitializeFrequencyChannelNumber ();
-    }
-  if (GetFrequency () == 0 && GetChannelNumber () == 0)
+
+  if (m_initialFrequency == 0 && m_initialChannelNumber == 0)
     {
-      ConfigureDefaultsForStandard ();
+      // set a default channel if the user did not specify anything
+      if (m_initialChannelWidth == 0)
+        {
+          // set a default channel width
+          m_initialChannelWidth = GetDefaultChannelWidth (m_standard, m_band);
+        }
+
+      m_operatingChannel.SetDefault (m_initialChannelWidth, m_standard, m_band);
     }
   else
     {
-      // The user has configured either (or both) Frequency or ChannelNumber
-      ConfigureChannelForStandard ();
+      m_operatingChannel.Set (m_initialChannelNumber, m_initialFrequency, m_initialChannelWidth,
+                              m_standard, m_band);
     }
+  m_operatingChannel.SetPrimary20Index (m_initialPrimary20Index);
+
   switch (standard)
     {
     case WIFI_PHY_STANDARD_80211a:
@@ -1403,9 +1104,6 @@
     case WIFI_PHY_STANDARD_80211p:
       Configure80211p ();
       break;
-    case WIFI_PHY_STANDARD_holland:
-      ConfigureHolland ();
-      break;
     case WIFI_PHY_STANDARD_80211n:
       Configure80211n ();
       break;
@@ -1417,7 +1115,7 @@
       break;
     case WIFI_PHY_STANDARD_UNSPECIFIED:
     default:
-      NS_ASSERT (false);
+      NS_ASSERT_MSG (false, "Unsupported standard");
       break;
     }
 }
